//    pic : 16f887 4MHz      //
// rev Paulfjujo
#define Version "180311"
// correction bug  void Check_Device(unsigned char dev_address,char Mode_Bavard)
// test en rajoutant module RTC DS1307 +24C32
#define Version "180310"

#define Directory "C:\\_MikroC\\_MesProjets_MikroC\\_16F887_Dip40_tests"
#define Projet "16F887_test_LCD_I2C_1803.mcppi"
#define Source "_16F887_LCD_I2C_test_"

// config
//CONFIG1 : $2007 : 0x2CF4
//CONFIG2 : $2008 : 0x0600

#define LCD_4x20
#define LCD_ADDR 0x4E        // adresse du PCF8574A = 0x7E. adresse du PCF8574 = 0x4E


// PCF8574 I2C LCD Port Definition
// P7,P6,P5,P4 = Data, P3=Backlight (BL), P2=E, P1=RW, P0=RS
#define LCD_BL 0x08
#define LCD_EN 0x04
#define LCD_RW 0x02
#define LCD_RS 0x01

// ref : ODT OCM-20416D-A2023 LCD Module  8/4/1999
// LCD Command
#define LCD_CLEAR 0x01
#define LCD_HOME  0x02
#define Display_ON 0x0C
#define Display_OFF 0x08
#define LCD_LINE1 0x80      // 0x00 + bit D7=1
#define LCD_LINE2 0xC0      // 0x40 + bit D7=1
#define LCD_LINE3 0x94      // 0x14 + bit D7=1
#define LCD_LINE4 0xD4      // 0x54 + bit D7=1

#define FOSC 4  // MHz

const code char mesg0[]="Mikroc 7.10 16F887 dip40 LCD4x20 I2C2 "Version"\n\r";
const code char mesg1[]="                    ";
const code char * Messages[]={mesg0,mesg1};
const char txt1[] = "I2C LCD  4x20  PCF8574T ";
const char txt2[] = "MCU PIC16f887 en DIP40";  // TEXTE dans le CODE FLASH ROM
unsigned char TEXTE[48];  // TEXTE en RAM
unsigned char *txt;
unsigned char CRam1[20];
unsigned char  I2C_Adresses_Devices[8];

sbit Bavard at RA3_bit ;
sbit Bavard_Dir at TRISA3_bit ;
sbit Led at RA4_bit ;
sbit Led_Dir at TRISA4_bit ;

unsigned int i,j,k;
unsigned char Addr;
unsigned char  donnee;
static unsigned char Nb;
unsigned int Etat;
unsigned int EA0;  // analog input
unsigned int v;

#define With_LCD_I2C
#define BAVARD  PORTA,3


void UART1_Write_CText(const char *txt);

unsigned char I2C_PCF8574_Write(unsigned char  Adr,unsigned char value);
void LCD_init_4x20(void);
void LCD_putcmd(unsigned char d,unsigned char cmdtype);
void LCD_putch(unsigned char d);
void LCD_Write_text(char *s);
void LCD_Write_CText(const char *txt) ;
void LCDHandler(char c);

void strConstRamCpy(unsigned char *dest, const code char *source);
void Check_Device(unsigned char dev_address, char mode);
void CRLF1(void);

void Erase_Line(int L);


void Check_Device(unsigned char dev_address,char Mode_Bavard)
{
char Cx;

if(Mode_Bavard>0)
{
UART1_Write_CText(" I2C Device at @ ");
  ByteToHex(dev_address,CRam1);
  UART1_Write_Text(CRam1);
}
 //if(dev_address==160) Synchro_SQ50=1;
 SSPCON.B7=0;  //WCOL_bit
 I2C1_Start();
 Cx=I2C1_Wr(dev_address);
  if(Cx == -1)             //check if collision happened
   {
    Cx = SSPBUF;            //empty the buffer,
    SSPCON.WCOL=0;     // clear the collision status bit
    }
  I2C_Stop();
 //Synchro_SQ50=0;
 if( Cx!=0 )
 {
  if(Mode_Bavard>0)UART1_Write_CText(" not found");
 }
 else
  {
   // I2C_Adresses_Devices[Nb++]=dev_address;   <-- erreur ici , car Nb++ plus bas !
   I2C_Adresses_Devices[Nb]=dev_address;
    if(Mode_Bavard>0)
    {

      UART1_Write_CText(" ... soit ");
      ByteToStr (dev_address,CRam1);
      UART1_Write_Text(CRam1);
      UART1_Write_CText("  Found OK  ");
      CRLF1();
     }
    Nb++;
  }
 I2C1_Stop();
 Delay_ms(50);
 while(I2C1_Is_Idle()==0);
 if(Mode_Bavard>0) CRLF1();
}

// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

    
void UART1_Write_CText(const char *txt)
 {
   while (*txt)
     {
     UART1_Write(*txt++);
    // Delay_us(500);
     }
}
void CRLF1(void)
{
UART1_Write(13);
UART1_Write(10);
}

 void LCD_CLS(void)
 {
   Erase_Line(4);
    Erase_Line(3);
     Erase_Line(2);
      Erase_Line(1);
 }

void Erase_Line(int L)
{
switch(L)
 {
 case 1:
  {
   LCD_putcmd(LCD_LINE1,1);
  LCD_Write_CText(mesg1);
  // LCD_Write_CText("                    ");
   LCD_putcmd(LCD_LINE1,1);
   break;
  }
  case 2:
  {
   LCD_putcmd(LCD_LINE2,1);
   LCD_Write_CText(mesg1);
   LCD_putcmd(LCD_LINE2,1);
    break;
  }
  case 3:
  {
   LCD_putcmd(LCD_LINE3,1);
  LCD_Write_CText(mesg1);
   LCD_putcmd(LCD_LINE3,1);
    break;
  }
  case 4 :
  {
   LCD_putcmd(LCD_LINE4,1);
   LCD_Write_CText(mesg1);
   LCD_putcmd(LCD_LINE4,1);
    break;
  }
 }
}

 //========== LCD 4x20 sur bus I2C ================================

 unsigned char I2C_PCF8574_Write(unsigned char Adr,unsigned char value)
{
 unsigned char S,dummy;
 I2C1_Start();
 S = I2C1_Wr( Adr );
 if(S == -1)        //check if bus collision happened
 {
   dummy = SSPBUF;        //upon bus collision detection clear the buffer,
   SSPCON.WCOL=0;    // clear the bus collision Etat bit
 }
 S = I2C1_Wr(value);
 I2C1_Stop();
 return(S);
}
/*
  PCA8574 I2C LCD Routine
  LCD Data PCA8574: P7,P6,P5,P4
  LCD Control: P3: Back Light, P2: E-Enable, P1:RW, P0: RS
*/
void LCD_putcmd(unsigned char d,unsigned char cmdtype)
{
  unsigned char lcddata;
  // Put the Upper 4 bits data
  lcddata = (d & 0xF0)|LCD_BL;
  Etat=I2C_PCF8574_Write(Addr,lcddata | LCD_EN);
  Delay_us(50);
  // Write Enable Pulse E: Hi -> Lo
  Etat=I2C_PCF8574_Write(Addr,lcddata & ~LCD_EN);
  Delay_us(50);      // Delay 1us for 16 MHz Internal Clock
  // cmdtype = 0; One cycle write, cmdtype = 1; Two cycle writes
  if (cmdtype) {
    // Put the Lower 4 bits data
    lcddata = ((d << 4) & 0xF0)|LCD_BL;
    Etat=I2C_PCF8574_Write(Addr,lcddata | LCD_EN);
    Delay_us(10);    // Delay 2us for 16 MHz Internal Clock
    // Write Enable Pulse E: Hi -> Lo
    Etat=I2C_PCF8574_Write(Addr,lcddata & ~LCD_EN);
    Delay_ms(5);    // Delay 1us for 16 MHz Internal Clock
  }
}

void LCD_putch(unsigned char d)
{
  unsigned char lcddata;
  // Put the Upper 4 bits data
  lcddata = (d & 0xF0)|LCD_BL|LCD_RS;
  Etat=I2C_PCF8574_Write(Addr,lcddata | LCD_EN);
  Delay_us(10);      // Delay 2us for 16 MHz Internal Clock
  // Write Enable Pulse E: Hi -> Lo
  Etat=I2C_PCF8574_Write(Addr,lcddata & ~LCD_EN);
  Delay_us(10);      // Delay 1us for 16 MHz Internal Clock
  // Put the Lower 4 bit data
  lcddata = ((d << 4) & 0xF0)|LCD_BL|LCD_RS;
  Etat=I2C_PCF8574_Write(Addr,lcddata | LCD_EN);
  Delay_us(10);      // Delay 2us for 16 MHz Internal Clock
  // Write Enable Pulse E: Hi -> Lo
  Etat=I2C_PCF8574_Write(Addr,lcddata & ~LCD_EN);
  Delay_us(25);      // Delay 1us for 16 MHz Internal Clock
}

void LCD_init_4x20(void)
{
  // Wait for more than 15 ms after VCC rises to 4.5 V
  Delay_ms(1000);
  // Send Command 0x30
  LCD_putcmd(0x30,0);
  // Wait for more than 4.1 ms
  Delay_ms(100);
  // Send Command 0x30
  LCD_putcmd(0x30,0);
  // Wait for more than 100 us
  Delay_ms(25);
  // Send Command 0x30
  LCD_putcmd(0x30,0);
    Delay_ms(25);
  // Function set: Set interface to be 4 bits long (only 1 cycle write).
  LCD_putcmd(0x25,0);
    Delay_ms(20);
  // Function set: DL=0;Interface is 4 bits, N=1; 2 Lines, F=0; 5x8 dots font)
  LCD_putcmd(0x28,1);
    Delay_ms(20);
  // Display Off: D=0; Display off, C=0; Cursor Off, B=0; Blinking Off
  LCD_putcmd(0x08,1);
    Delay_ms(20);
  // Display Clear
  LCD_putcmd(LCD_CLEAR,1);
    Delay_ms(100);
  // Entry Mode Set: I/D=1; Increament, S=0; No shift
  LCD_putcmd(0x06,1);
    Delay_ms(20);
  // Display On, Cursor Off
  LCD_putcmd(0x0C,1);
    Delay_ms(20);
}

void LCD_putsRom(const code char *s)
{int i=0;
  while((*s != 0)&& (i<20))
  {
    LCD_putch(*s);
    s++;i++;
  }
}

void LCD_Write_Text( char *s)
{int i=0;
  while((*s != 0)&& (i<20))
  {
    LCD_putch(*s);
    s++;
    i++;
  }
}

void LCD_Write_CText(const char *txt)
{
   while (*txt)
   LCD_putch(*txt++);
 }

void LCDHandler(char c) {
  LCD_putch(c);
}


void main()
{
  OSCCON=0;
  OSCCON.IRCF2=1;   // 4MHz
  OSCCON.IRCF1=1;
  OSCCON.IRCF0=0;
  OSCCON.SCS=1;
  //OSCCON=0b01110001 ; // 8MHz (111) & SCS=1  (sinon 4 MHz par defaut)
  //OSCCON=0b01100001 ; // 4 MHz par defaut
  //OSCCON = 0b11110010;   // configuration osc interne 32Mhz  (avec PLL)

    ANSEL  = 0x01; // Configure AN0 as analog
    ANSELH = 0;
    TRISA=0xFF;
    Bavard_Dir=1;
    Led_Dir=0;
    Led=0;
    TRISB=0xFF;
    TRISC = 0xFF;
    PORTC = 0x00;
    TRISD=0;   // 8 leds
    PORTD = 0;
    C1ON_bit = 0;                      // Disable comparators
    C2ON_bit = 0;
    EA0=0;

    // 1er test hardware
    // pour verif FOSC

    for (j=0;j<3;j++)
    {
     Led=!Led;
     Delay_ms(1000);
    }
    txt=TEXTE;

    UART1_Init(9600);
    /*test sortie direct live TX UART
    TXREG='A'; Delay_ms(10);
    TXREG='B'; Delay_ms(10);
    TXREG='C'; Delay_ms(10);
    CRLF1();
    */
    CRLF1();
    UART1_Write_CText(mesg0);
    UART1_Write_CText("Test LCD en mode I2C\r\n");
    UART1_Write_CText(txt1); CRLF1();
    UART1_Write_CText(txt2); CRLF1();
    CRLF1();

    UART1_Write_CText(" Init I2C  100KHz\r\n");
    I2C1_Init(100000);

    Delay_ms(500);                         // ajout delay 500ms

    if (Bavard==1)
       UART1_Write_CText(" Pin RA3  1 => mode Bavard ACTIF \r\n") ;
       else
         UART1_Write_CText(" Pin RA3  0 => mode Bavard dsactiv \r\n") ;
    for (i=0;i<8;i++) I2C_Adresses_Devices[i]=0;
    Nb=0;   // Nb de device sur le bus
    for (i=32;i< 253;i=i+2)  // adresse paires seulement ( adresse impaire  Lecture)
    {
     if (Bavard==1)     // RA3 au 0V
        Check_Device(i,1)  ;
          else   
          Check_Device(i,0)  ;
     }

    CRLF1();
    // si on est pas en mode Bavard
    //  si les details ne sont pas affichs
    // on affichera que les devices decouverts sur le bus
    if ((Bavard==0) &&(Nb>0))
     {
         UART1_Write_CText(" Device sur le bus I2C \r\n") ;
         for (i=0;i<Nb;i++)
         {
          UART1_Write_CText(" Device trouv at @ ");
          ByteToHex(I2C_Adresses_Devices[i],CRam1);
          UART1_Write_Text(CRam1);
          UART1_Write_CText("h ... soit ");
          ByteToStr (I2C_Adresses_Devices[i],CRam1);
          UART1_Write_Text(CRam1);
          CRLF1();
          }
     }
    UART1_Write_CText(" Fin de recherche device \r\n") ;
    CRLF1();
    
    Addr=LCD_ADDR;   // 4E   A0=1 A1=1 A2=1
    LCD_init_4x20();
    Delay_ms(50);
    LCD_putcmd(LCD_CLEAR,1);
    Delay_ms(50);// LCD Clear
    LCD_CLS();
    Delay_ms(1000);
    
    ADC_Init();
    
   j=0;
   do
   {
       // Presentation sur LCD
     LCD_putcmd(LCD_LINE1,1);
     Delay_ms(50);  // sans ce delai ,les 3 premiers caracteres sont bouffes sur le LCD
     LCD_Write_CText("16F887    Q= 4MHz    ");
     LCD_putcmd(LCD_LINE2,1);
     Delay_ms(50);  // sans ce delai ,les 3 premiers caracteres sont bouffes sur le LCD
     LCD_Write_CText("Version I2C  400Khz ");
     LCD_putcmd(LCD_LINE3,1);
     Delay_ms(50);
   
     EA0=ADC_Read(0) ;
     // 1ere faon      //12345678901234567890
     strConstRamCpy(txt,"EA0 = 00000  pts     ");
     WordToStr(v, CRam1);
     k=strlen(CRam1);
     strncpy(txt+6,CRam1,k-1);
     LCD_Write_Text(txt);

     UART1_Write_Text(txt);
     
     // si Ualim =4.096V     4mV par point
     v=EA0  <<2;
     CRam1[0] = (v/10000);
     if ((v/10000)==0) CRam1[0] =' '; else CRam1[0] = (v/10000)+48;
     CRam1[1] = ((v/1000)%10)+48;
     CRam1[2] ='.';
     CRam1[3] = ((v/100)%10)+48;
     CRam1[4] = ((v/10)%10)+48;
     CRam1[5]  = 0;
     LCD_putcmd(LCD_LINE4,1);
     Delay_ms(50);  // sans ce delai ,les 3 premiers caracteres sont bouffes sur le LCD
     LCD_Write_CText("Voltage = ");
     LCD_putcmd(LCD_LINE4+10,1);  Delay_ms(50);
     LCD_Write_Text(CRam1);
     LCD_putcmd(LCD_LINE4+17,1); Delay_ms(50);
     LCD_Write_CText("V");
     
     UART1_Write_CText(" soit  ");
     UART1_Write_Text(CRam1);
     UART1_Write_CText(" V \r\n");
     Delay_ms(2000);
    Led=!Led;
    }
    while(1);
} 

/*


    ABC

Mikroc 7.10 16F887 dip40 LCD4x20 I2C2 180311
Test LCD en mode I2C
I2C LCD  4x20  PCF8574T
MCU PIC16f887 en DIP40

 Init I2C  100KHz
 Pin RA3  0 => mode Bavard dsactiv

 Device sur le bus I2C
 Device trouv at @ 4Eh ... soit  78
 Fin de recherche device

EA0 = 24230  pts      soit   1.78 V


   Init I2C  100KHz
 Pin RA3  0 => mode Bavard dsactiv

 Device sur le bus I2C
 Device trouv at @ 4Eh ... soit  78
 Device trouv at @ A0h ... soit 160
 Device trouv at @ D0h ... soit 208
 Fin de recherche device
 

EA0 =   710  pts      soit   0.25 V
EA0 =   250  pts      soit   0.54 V
EA0 =   540  pts      soit   0.29 V


si RA3=1;

ABC

Mikroc 7.10 16F887 dip40 LCD4x20 I2C2 180310
Test LCD en mode I2C
I2C LCD  4x20  PCF8574T
MCU PIC16f887 en DIP40

 Init I2C  100KHz
 Pin RA3  1 => mode Bavard ACTIF
 I2C Device at @ 20 not found
 I2C Device at @ 22 not found
 I2C Device at @ 24 not found
 I2C Device at @ 26 not found
 I2C Device at @ 28 not found
 I2C Device at @ 2A not found
 I2C Device at @ 2C not found
 I2C Device at @ 2E not found
 I2C Device at @ 30 not found
 I2C Device at @ 32 not found
 I2C Device at @ 34 not found
 I2C Device at @ 36 not found
 I2C Device at @ 38 not found
 I2C Device at @ 3A not found
 I2C Device at @ 3C not found
 I2C Device at @ 3E not found
 I2C Device at @ 40 not found
 I2C Device at @ 42 not found
 I2C Device at @ 44 not found
 I2C Device at @ 46 not found
 I2C Device at @ 48 not found
 I2C Device at @ 4A not found
 I2C Device at @ 4C not found
 I2C Device at @ 4E ... soit  78  Found OK

 I2C Device at @ 50 not found
 I2C Device at @ 52 not found
 I2C Device at @ 54 not found
 I2C Device at @ 56 not found
 I2C Device at @ 58 not found
 I2C Device at @ 5A not found
 I2C Device at @ 5C not found
 I2C Device at @ 5E not found
 I2C Device at @ 60 not found
 I2C Device at @ 62 not found
 I2C Device at @ 64 not found
 I2C Device at @ 66 not found
 I2C Device at @ 68 not found
 I2C Device at @ 6A not found
 I2C Device at @ 6C not found
 I2C Device at @ 6E not found
 I2C Device at @ 70 not found
 I2C Device at @ 72 not found
 I2C Device at @ 74 not found
 I2C Device at @ 76 not found
 I2C Device at @ 78 not found
 I2C Device at @ 7A not found
 I2C Device at @ 7C not found
 I2C Device at @ 7E not found
 I2C Device at @ 80 not found
 I2C Device at @ 82 not found
 I2C Device at @ 84 not found
 I2C Device at @ 86 not found
 I2C Device at @ 88 not found
 I2C Device at @ 8A not found
 I2C Device at @ 8C not found
 I2C Device at @ 8E not found
 I2C Device at @ 90 not found
 I2C Device at @ 92 not found
 I2C Device at @ 94 not found
 I2C Device at @ 96 not found
 I2C Device at @ 98 not found
 I2C Device at @ 9A not found
 I2C Device at @ 9C not found
 I2C Device at @ 9E not found
 I2C Device at @ A0 ... soit 160  Found OK

 I2C Device at @ A2 not found
 I2C Device at @ A4 not found
 I2C Device at @ A6 not found
 I2C Device at @ A8 not found
 I2C Device at @ AA not found
 I2C Device at @ AC not found
 I2C Device at @ AE not found
 I2C Device at @ B0 not found
 I2C Device at @ B2 not found
 I2C Device at @ B4 not found
 I2C Device at @ B6 not found
 I2C Device at @ B8 not found
 I2C Device at @ BA not found
 I2C Device at @ BC not found
 I2C Device at @ BE not found
 I2C Device at @ C0 not found
 I2C Device at @ C2 not found
 I2C Device at @ C4 not found
 I2C Device at @ C6 not found
 I2C Device at @ C8 not found
 I2C Device at @ CA not found
 I2C Device at @ CC not found
 I2C Device at @ CE not found
 I2C Device at @ D0 ... soit 208  Found OK

 I2C Device at @ D2 not found
 I2C Device at @ D4 not found
 I2C Device at @ D6 not found
 I2C Device at @ D8 not found
 I2C Device at @ DA not found
 I2C Device at @ DC not found
 I2C Device at @ DE not found
 I2C Device at @ E0 not found
 I2C Device at @ E2 not found
 I2C Device at @ E4 not found
 I2C Device at @ E6 not found
 I2C Device at @ E8 not found
 I2C Device at @ EA not found
 I2C Device at @ EC not found
 I2C Device at @ EE not found
 I2C Device at @ F0 not found
 I2C Device at @ F2 not found
 I2C Device at @ F4 not found
 I2C Device at @ F6 not found
 I2C Device at @ F8 not found
 I2C Device at @ FA not found
 I2C Device at @ FC not found

 Fin de recherche device


 */